<template>
    <div class="">
            <page-header title="Rôles">

            </page-header>
            <div class="col-md-12">
              <div :class="['card bg-transparent']" >
               <div :class="['card-header pl-0']">
                    <h3 class="card-title mb-0">
                        <button @click="showModalOnCreate"  class="ml-4 btn btn-xs btn-secondary text-xs"> 
                           <i class="fas fa-plus-circle right"></i>  Nouveau rôle
                        </button>
                    </h3>

                    <div class="card-tools d-flex">
                         <filter-bar ref="filterBar"></filter-bar>
                    </div>
              </div>
              <!-- /.card-header -->
              <div class="card-body table-responsive  p-0 position-relative " v-show="!NoDataForSearch && !NoDataAtAll" >
                    <vuetable :css="table" ref="vuetable" api-url="api/roles" :fields="columns" 
                           pagination-path=""
                           :per-page="15"
                           :http-options="httpOptions"
                           @vuetable:loading="onLoading" 
                           @vuetable:loaded="onLoadingDone"
                           :append-params="moreParams" 
                           @vuetable:pagination-data="onPaginationData">
                            <template slot="actions" slot-scope="props">   
                            <div class="custom-actions">
                                
                                <router-link :to="'roles/'+props.rowData.id" class="btn btn-xs btn-secondary"
                                @click="remove(props.rowData.id)">
                                <i class="fas fa-edit"></i>
                                </router-link>
                                <button class="btn btn-xs btn-danger"
                                @click="remove(props.rowData.id)">
                                <i class="fas fa-trash"></i>
                                </button>
                            </div>
                            </template>
                            <template slot="permissions" slot-scope="props">   
                            <div class="">
                                    <span>{{props.rowData.permissions_count }}</span>
                            </div>
                            </template>
                    </vuetable>
              </div>
              <pa ref="pagination" :is-loading="isLoading"  :pager="[15,25,50,100]" @vuetable-pagination:change-page="onChangePage" v-show="!NoDataForSearch && !NoDataAtAll"   ></pa>
              <!-- /.card-body -->
               </div>
               <no-data-in-search v-show="pageInit" :search="searchTxt" :show="NoDataForSearch" :data-empty="NoDataAtAll"></no-data-in-search>
              <!-- Modal dbt -->
              <b-modal @hidden="reset"  ref="inputModal" id="my-modal" :title="ModalTitle"  :hide-footer="true">
                <form class="" method="POST"  @submit.prevent="onSubmit()"
                               @reset.prevent="reset()" 
                               @keydown="form.errors.clear($event.target.name)" 
                               @change="form.errors.clear($event.target.name)">
                        <div class="form-group ">
                            <label class="">Libellé du rôle</label>
                            <input autocomplete="off" class="form-control form-control-sm " name="libelle" v-model="form.libelle" type="text"/>
                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('libelle')" v-text="form.errors.get('libelle')"></span>
                        </div>
  

                      <div class="m-form__actions m-form__actions--solid" style="    display: flex;align-items: center;justify-content: flex-end;">
														<button type="submit" :class="['btn btn-success btn-small mr-2',isLoading ? 'm-loader m-loader--sm m-loader--light m-loader--right' :'']" :disabled="form.errors.any()">{{ isLoading ? "Processus en cours..." : ModalAction }}</button>
											</div>
               </form>
            </b-modal>
            <!-- Modal fin -->
</div>
    </div>
</template>

<script>

   import  Vuetable from "vuetable-2/src/components/Vuetable";
   import pa from './../../../components/pagination/Pagination'
   import Form from "./../../../classes/Form"
   import Master from "./../../Master.vue";


    export default {
        mixins: [Master],
        data(){
            return{
                modeEdit:false,
                ftime:true,
                hasData:false,
                form : new Form({
                    libelle:""
                }),
                moreParams:{filter:''},
                isLoading:false,
                columns : [
                {
                    name: 'libelle',
                    title: "Libellé"
                },
                {
                name: '__slot:permissions',   // <----
                title: 'Nbre de permissions',
                titleClass: 'center aligned',
                dataClass: 'center aligned'
                },
                {
                    name: 'created_at',
                    title: "Date d'enregistrement",
                    callback: 'formatDate|D-MM-Y à H:mm'
                },
                {
                name: '__slot:actions',   // <----
                title: 'Actions',
                titleClass: 'center aligned',
                dataClass: 'center aligned'
                }
                ],
                  table: {
                    tableWrapper: '',
                    tableHeaderClass: 'mb-0',
                    tableBodyClass: 'mb-0',
                    tableClass: 'table table-striped table-hover',
                    ascendingIcon: 'fa fa-chevron-up',
                    descendingIcon: 'fa fa-chevron-down',
                    ascendingClass: 'sorted-asc',
                    descendingClass: 'sorted-desc',
                    sortableIcon: 'fa fa-sort',
                    detailRowClass: 'vuetable-detail-row',
                    handleIcon: 'fa fa-bars text-secondary',
                    renderIcon(classes, options) {
                      return `<i class="${classes.join(' ')}"></span>`
                    }
                  }
            }
        },
        created()
        {
          this.modeEdit = false
 
        },
        mounted() {
                 this.$events.$on('filter-set', eventData => this.onFilterSet(eventData))
                 this.$events.$on('filter-reset', e => this.onFilterReset())
        },
        computed:
        {
            ModalTitle ()
            {
              return  this.modeEdit ? " Modification d'un rôle"  : " Ajout d'un rôle"
            },
            ModalAction ()
            {
              return  this.modeEdit ? " Modifier"  : " Ajouter"
            },
            shouldGoToFirstPage()
            {
              if(this.$refs.vuetable)
              {
                return (this.$refs.vuetable.tableData.length) - 1 == 0
              } 
              else
              {
                return false
              }
            },
            filterBarIsFilled()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  return this.moreParams.filter != "" ? true : false
                else
                 return false
            },
            searchTxt()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  return this.moreParams.filter
                else
                 return ""
            },
            NoDataForSearch()
            {

              return (this.hasData == false && this.filterBarIsFilled == true ) ? true : false
            
            },

            NoDataAtAll()
            {

              return (this.hasData == false && this.filterBarIsFilled == false ) ? true : false
            
            }
        },
        methods: 
        {
            formatDate: function(value, fmt) 
            {
               return  toDateFormat(value, fmt)
            },
            onPaginationData (paginationData) 
            {
              if(this.pageInit==false)
                 this.pageInit =true
              else
              {
                
              }
              this.hasData = paginationData.data.length > 0
              this.$refs.pagination.setPaginationData(paginationData)
            },
            onChangePage (page) 
            {
               
               this.$refs.vuetable.changePage(page)
            },
            onLoading() 
            {

               this.isLoading = true
                if(this.ftime==false)
                {
                    $('table.vuetable').block({ 
                        message: '<div class="blockui"><span>Patientez svp</span><span><div class="kt-spinner kt-spinner--v2 kt-spinner--danger "></div></span></div>', 
                        css: { border: 'none' },
                                                
                            // styles for the overlay 
                            overlayCSS:  { 
                                backgroundColor: '#000', 
                                opacity:         0.06, 
                                cursor:          'wait' 
                            },
                    }); 
                    
                }
                this.ftime = false
            },
            onLoadingDone() 
            {
               this.isLoading = false
                if(this.ftime==false)
                {
                    $('table.vuetable').unblock()
                }
            },
            onAction (action, data, index) {
            console.log('slot) action: ' + action, data, index)
            },
            onFilterSet (filterText) {
                this.moreParams = {
                    'filter': filterText
                }
                Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            onFilterReset () {
                this.moreParams = {}
                Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            //Retire un role de la BDD
             remove(e)
             {
                 
                  
                  //On demande la confirmation de la suppression
                    alertConfirm("Voulez-vous supprimer ce rôle ?","Suppréssion d'un rôle")
                    .then(result => {
                        //On réinitialise le chargement
                        this.isLoading = true
                        if(result)
                        {
                           axios.delete("api/roles/"+e).then((response) => 
                            { 
                             // on rafraichit la page de donnée actuelle
                              !this.shouldGoToFirstPage ? this.$refs.vuetable.reload() : this.$refs.vuetable.refresh()
                              //on notifie l'effectivité de la suppréssion
                              flash('Suppresion réussie')
                              //On réinitialise le chargement
                              this.isLoading = false

                            },
                            (error) =>
                            {
                              this.isLoading = false
                            });
                        }
                    })
                    .catch(error => {
                        reject(error);
                    });
             },
             //Gere l'action du formulaire
             onSubmit()
             {
                 //On réinitialise le chargement
                this.isLoading = true
                //Si on edite pas
                if(!this.modeEdit)
                  //on ajoute un nouveau
                   this.add()
                else 
                //alors on actualise
                  this.update()
             },
            //Ajoute un role dans la BDD
            add()
            {
                //Requête ajax
                this.form.post("api/roles").then((value) => 
                {  
                  this.reset()
                  // on ramène les données sur la page 1
                  this.$refs.vuetable.refresh()
                  flash("<span>Enregistré <strong>avec succès</strong></span>")

                },
                (error) =>
                {
                  this.isLoading = false
                });                  
            },
            //Actualise  un role dans la BDD
            update()
            {
              
                //Requête ajax
                this.form.patch("api/roles/"+this.form.id).then((value) => 
                {
                  
                   // on rafraichit la page des données actuelle
                  this.$refs.vuetable.reload()
                  //On remet à zero notre formulaire
                  this.reset()
                  //on affiche le message 
                  flash("<span>Modifié <strong>avec succès</strong></span>")
                  

                },
                (error) =>
                {
                  this.isLoading = false
                  //on affiche le message 
                  flash("<span>Ajout <strong>impossible</strong></span>","danger")
                });                  
            },
            //On affiche le modal pour la création
            showModalOnCreate()
            {
                this.$router.push("/roles/ajout") 
            },
            //On affiche le modal pour l'édition
            showModalOnEdit(entity)
            {
               
                this.reset()
                this.modeEdit = true
                this.form.libelle = entity.libelle
                this.form.id=entity.id
                this.$refs['inputModal'].show()
             },
              //Initialisation du formulaire
              reset()
             {
                  this.form.libelle = ""
                  this.$refs['inputModal'].hide()
                  this.modeEdit = false
                  this.isLoading = false
                  if(this.moreParams.hasOwnProperty('filter'))
                  this.moreParams.filter=""
             },
              
        },
        components:
        {

            Vuetable,
            pa
        }
    }
</script>